# Utterly Automated Artifact Versioning with GitVersion

## If This Helps You, Please Star This Project :)

One click can help us keep providing and improving Guided Explorations.  If you find this information helpful, please click the star on this project's details page! [Project Details](https://gitlab.com/guided-explorations/guided-explorations/devops-patterns/utterly-automated-versioning)

## Overview Information

GitLab's features are constantly and rapidly evolving and we cannot keep every example up to date.  The date and version information are published here so that you can assess if new features mean that the example could be enhanced or does not account for an new capability of GitLab.

- **Product Manager For This Guided Exploration**: Darwin Sanoy (@DarwinJS)

- **Publish Date**: 2021-06-25
- **GitLab Version Released On**: 14.0

- **Update Date**: 2024-05-03
- **GitLab Version Updated On**: 16.10

- **GitLab Edition Required**: 

  - For overall solution: [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/) 

    [Click to see Features by Edition](https://about.gitlab.com/features/) 

- **Tested On**: 
  - GitLab Docker-Executor Runner

- **References and Featured In**:
  - Please see [Release CI/CD examples](https://docs.gitlab.com/ee/user/project/releases/release_cicd_examples.html) for many rich examples for triggering a release only on specific conditions.

## Merge Sequencing of Long Running Branches

The following merge sequence is implied by the usage of gitversion and wanting distinct package versioning by purpose and to have the packages be retained for repushing to various environments.

1. From "main" create a branch that starts with "feature-" like "feature-my-new-thing"
2. Merge "feature-my-new-thing" to develop with "Delete source branch" enabled (default)
3. Merge "develop" to "release" with "Delete source branch" DISabled (Default)
4. Merge "release" to "main" with "Delete source branch" DISabled (Default)

## Demonstrates These Design Requirements, Desirements and AntiPatterns

- **GitLab CI Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** This project shows two built-in GitLab debug tracing variables 
  - `CI_DEBUG_TRACE` - built-in standard GitLab CI tracing documented in [Debug logging](https://docs.gitlab.com/ee/ci/variables/#debug-logging)
  - `TRACE` - built-in for tracing helm commands in AutoDevOps - which seems undocumented
  - `CI_SCRIPT_TRACE` - custom example for enabling tracing of one's CI scripts. Example enables `set -xv` and has some custom messages to emit special data.  Allows focusing on just your own code without enabling the massive verbosity of `CI_DEBUG_TRACE`
  - `CI_GITVERSION_TRACE` - custom example of having specific code in this solution emit extra data. In this case it has to run the utility twice - so potentially an expensive operation to get tracing data as well as generating a lot of extra output - so controlled by a switch.
  - `GIT_TRACE_PERFORMANCE` - enables tracing of performance data, showing how long each particular git invocation takes. From https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
  - `GIT_TRACE_SETUP` - enables tracing of what git is discovering about the repository and environment it’s interacting with. From https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
  - `GIT_TRACE_PACKET` - enables packet-level tracing for network operations.
  - `GIT_CURL_VERBOSE` - Git uses the curl library to do network operations over HTTP, so GIT_CURL_VERBOSE tells Git to emit all the messages generated by that library. From https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
  - More git tracing variables at https://git-scm.com/book/en/v2/Git-Internals-Environment-Variables#_debugging
- **Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** Complex artifact versioning handling for busy repositories that generate versioned artifacts on every build.
- **GitVersion Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** Dynamically determine unique version numbers for each branch - including prerelease modifiers.  Automatic incrementing during merging to release branches.
- **GitLab Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** Leveraging GitLab Release and release-cli to create GitLab Releases and git tag the release commits.
- **GitLab Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** GitLab Releases and release-cli leveraging the generated version number.
- **GitLab Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** GitLab Generic package creation and retrieval test leveraging the generated version number.
- **GitLab Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** GitLab NuGet package creation and retrieval test leveraging the generated version number.
- **GitLab Development Pattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** Docker Container creation leveraging the generated version number.
- **DevOps AntiPattern [![FC](https://gitlab.com/guided-explorations/guided-exploration-concept/-/raw/master/images/FC.png)](https://about.gitlab.com/features/):** This workflow recreates the packages / container from scratch when you merge into each protected branch. In a better DevOps world, one would promote the exact same binary asset instead of rebuilding.

### Uses and features for Generic Packages (Released in 13.5)

- Any file can be uploaded and retrieved, including tar / zip archives.
- No built-in expression or resolution of dependencies - because there is no client side package manager utility.
- A Package Manager type that is not yet supported (e.g. Yum)
- GitLab “Releases” functionality is slated use Generic packages as it's storage mechanism in the future.
- Note: Some Package Managers can treat disk files as a repository for dependency resolution (e.g. Yum)- and sometimes you can combine that will actual package endpoints (e.g. Chocolatey NuGet)

### Uses GitLab CI Components

- GitVersion functionality has been migrated to the [Ultimate Auto Semversioning Component](https://gitlab.com/explore/catalog/guided-explorations/ci-components/ultimate-auto-semversioning)

### Cross References and Documentation

- [GitVersion Documentation](https://gitversion.net/docs/)
- [Generic Packages Feature Help](https://docs.gitlab.com/ee/user/packages/generic_packages/)
- [NuGet Packages Feature Help](https://docs.gitlab.com/ee/user/packages/nuget_repository/)
- [GitLab Releases Feature Help](https://docs.gitlab.com/ee/user/project/releases/)
- [GitLab release-cli Help](https://gitlab.com/gitlab-org/release-cli/-/tree/master/docs)
- [GitLab Container Registry Help](https://docs.gitlab.com/ee/user/packages/container_registry/)

# GitVersion - Open Source Artifact Versioning

GitVersion:
1. Solves a [dizzying array of artfact / release versioning problems](https://gitversion.net/docs/learn/why) for busy repositories...
2. Through almost [artificially intelligent default behaviors](https://gitversion.net/docs/reference/version-increments)...
3. That analyze your git metadata (branch names, tags, etc)...
3. But that can be overridden by [extensive configuration](https://gitversion.net/docs/reference/configuration)...

This Guided Exploration is only minimal changes from default behaviors.  You can look through the artifacts created and the merge history and the jobs from the merge history to see what it has done in this project.

It's hard to describe all the artifact versioning problems Gitversioning solves.

Maybe a good summary is that it uses your branching naming convention, tags and commont git flows to determine what the artifact version should be.

It follows convention over configuration - so you can apply minimum configuration to get the desired results.

### GitVersion CI CD Plugin Extension Specifics

1. You must override GitLab CI's normal clone by setting `GIT_STRATEGY: none` and use the command line of gitversion to dynamically clone the full repository.
2. `Enable merged results pipelines` should be disabled.
3.  `Enable "Delete source branch" option by default` should be on so that development branches will be deleted in favor of tags.  Protected branches do not show the option nor perform it - so `main`, `release` and `develop` will be safe from deletion in the Merge Request UI.

### This Repository Uses the following workflow

This means to make changes you must:
1. Create a branch from develop branch to a feature branch - named "feature-SOMETHING" - generated packages collected only as job artifacts and not download tested
2. Merge back to develop (tag = alpha) - generated packages pushed and tested from package registry.
3. Merge to release (tag = beta) - generated packages pushed and tested from package registry.
4. Merge to main (no version prerelease tag) - generated packages pushed and tested from package registry and GitLab Release created.

'main', 'release' and 'develop' branches are protected to prevent direct changes and the GitLab CI pipline only creates GitLab Releases on merges to a protected branch.

# NuGet Packaging
- Demonstrates both dotnet cli and nuget cli  - create, publish, retrieve.
- Demonstartes generic packages - create, publish, retrieve.

## Guided Explorations Concept

This Guided Exploration is built according to a specific vision and requirements that maximize its value to both GitLab and GitLab's customers.  You can read more here: [The Guided Explorations Concept](https://gitlab.com/guided-explorations/guided-exploration-concept/blob/master/README.md)

## Working Design Pattern

As originally built, this design pattern works and can be tested. In the case of plugin extensions like this one, the working pattern may be it's use in another Guided Exploration.
